# -*- coding: utf-8 -*-
"""
Created on Mon Nov 11 15:17:47 2024

@author: Giovanni
"""

import numpy as np
import matplotlib.pyplot as plt
from AAKR_reconstruction import AAKR_reconstruction_ex  # Import the AAKR reconstruction function

# Parameters of the optimization
n_step = 10
h_min = 0.01
h_max = 2.0

# Build vector h of bandwidth values to be tried
h = np.linspace(h_min, h_max, n_step)

# Prepare to store RMSE values for each h
rmse = []

# Turn off interactive plotting
plt.ioff()

# Perform optimization
for i in range(n_step):
    print(f"Step {i+1}/{n_step}")
    
    # Call the AAKR reconstruction function for each bandwidth value
    test_reconstruction, rmse_val = AAKR_reconstruction_ex('train.dat', 'validation.dat', h[i])
    rmse.append(rmse_val)
    
    # Close all figures generated in each iteration
    plt.close('all')

# Turn on interactive plotting
plt.ion()

# Plot RMSE against bandwidth values
plt.figure()
plt.plot(h, rmse, '.', label='Reconstruction Error')
plt.xlabel('Bandwidth (h)')
plt.ylabel('RMSE')
plt.legend()
plt.show()
